'use strict';

exports.__esModule = true;
exports.default = connect;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _mapStateToProps2 = require('./mapStateToProps');

var _mapStateToProps3 = _interopRequireDefault(_mapStateToProps2);

var _mapDispatchToProps2 = require('./mapDispatchToProps');

var _mapDispatchToProps3 = _interopRequireDefault(_mapDispatchToProps2);

var _mergeProps2 = require('./mergeProps');

var _mergeProps3 = _interopRequireDefault(_mergeProps2);

var _mixin = require('./mixin');

var _mixin2 = _interopRequireDefault(_mixin);

var _isDisplayComponent = require('./isDisplayComponent');

var _isDisplayComponent2 = _interopRequireDefault(_isDisplayComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function connect(_mapStateToProps, _mapDispatchToProps, _mergeProps, _options) {

  var options = _options || {};

  return function (Component) {

    var mapStateToProps = _mapStateToProps || Component.prototype.mapStateToProps || _mapStateToProps3.default;
    var mapDispatchToProps = _mapDispatchToProps || Component.prototype.mapDispatchToProps || _mapDispatchToProps3.default;
    var mergeProps = _mergeProps || Component.prototype.mergeProps || _mergeProps3.default;
    var store = options.store || Component.prototype.store;
    var componentInitialize = Component.prototype.initialize;
    var componentOnRender = Component.prototype.onRender;
    var componentOnDestroy = Component.prototype.onDestroy;
    var getInitialState = Component.prototype.getInitialState || function () {
      return {};
    };

    var connectMixin = _underscore2.default.defaults({}, {

      getInitialState: getInitialState,

      initialize: function initialize(_initOptions) {

        var initOptions = _initOptions || {};

        _mixin2.default.initialize.call(this, {
          mapStateToProps: mapStateToProps,
          mapDispatchToProps: mapDispatchToProps,
          mergeProps: mergeProps,
          store: store,
          props: initOptions.props
        });

        if (componentInitialize) {
          componentInitialize.apply(this, arguments);
        }
      },
      onRender: function onRender() {

        _mixin2.default.onRender.apply(this, arguments);

        if (componentOnRender) {
          componentOnRender.apply(this, arguments);
        }
      },
      onDestroy: function onDestroy() {

        _mixin2.default.onDestroy.apply(this, arguments);

        if (componentOnDestroy) {
          componentOnDestroy.apply(this, arguments);
        }
      }
    }, _mixin2.default);

    if (!(0, _isDisplayComponent2.default)(Component)) {
      connectMixin = _underscore2.default.omit(connectMixin, 'onRender');
    }

    return Component.extend(connectMixin);
  };
}